import time

def objective_function(queue,configuration,workspace,search_settings,debug=False):
    queue.put("failed")
    start_time = time.time()

    connector_choice=0
    data_preparation_choice=configuration["data_preparation"]
    modeling_choice=configuration["modeling"]


    exec(f"from {workspace} import data_preparation_{connector_choice}_{data_preparation_choice}", globals())

    exec(f"X_train, X_test, y_train, y_test = data_preparation_{connector_choice}_{data_preparation_choice}.process_data()", globals())

    exec(f"from {workspace} import modeling_{connector_choice}_{modeling_choice}", globals())

    exec(f"y_pred= modeling_{connector_choice}_{modeling_choice}.generate_model(X_train, y_train, X_test)", globals())

    exec(f"from {workspace}.post_processing_{connector_choice}_0 import generate_evaluation" , globals())


    score=generate_evaluation(y_test,y_pred)


    current_time = time.time()
    elapsed_time = current_time - start_time

    print("Score:", score)
    print("Elapsed time:", elapsed_time)

    if search_settings["max"]:
        queue.put(-score)
        return -score
    else:
        queue.put(score)
        return score
